Raritan PX2/PX3 JSON-RPC API

Inlet.idl
1 /* SPDX-License-Identifier: BSD-3-Clause */
2 /*
3 * Copyright 2009 Raritan Inc. All rights reserved.
4 */
5
6 #ifndef __PDUMODEL_INLET_IDL__
7 #define __PDUMODEL_INLET_IDL__
8
9 #include <EDevice.idl>
10 #include <Nameplate.idl>
11 #include <NumericSensor.idl>
12 #include <StateSensor.idl>
13 #include <Pole.idl>
14 #include <ResidualCurrentStateSensor.idl>
15
16 /**
17 * PDU Model
18 */
19 module pdumodel {
20
21 /** %Inlet interface */
22 interface Inlet_2_0_4 extends EDevice {
23
24 /** %Inlet metadata */
25 structure MetaData {
26 string label; ///< %Inlet label
27 string plugType; ///< Plug type
28 Nameplate_2_0_0 namePlate; ///< %Nameplate information
29 Rating_2_0_0 rating; ///< Numerical usage ratings
30 };
31
32 /** %Inlet sensors */
33 structure Sensors {
34 sensors.NumericSensor_4_0_3 voltage; ///< RMS voltage sensor
35 sensors.NumericSensor_4_0_3 current; ///< RMS current sensor
36 sensors.NumericSensor_4_0_3 peakCurrent; ///< Peak current sensor
37 sensors.NumericSensor_4_0_3 residualCurrent; ///< Residual current sensor
38 sensors.NumericSensor_4_0_3 residualDCCurrent; ///< DC Residual current sensor
39 sensors.NumericSensor_4_0_3 activePower; ///< Active power sensor
40 sensors.NumericSensor_4_0_3 reactivePower; ///< Reactive power sensor
41 sensors.NumericSensor_4_0_3 apparentPower; ///< Apparent power sensor
42 sensors.NumericSensor_4_0_3 powerFactor; ///< Power factor sensor
43 sensors.NumericSensor_4_0_3 displacementPowerFactor; ///< Displacement power factor sensor
44 sensors.NumericSensor_4_0_3 activeEnergy; ///< Active energy sensor
45 sensors.NumericSensor_4_0_3 apparentEnergy; ///< Apparent energy sensor
46 sensors.NumericSensor_4_0_3 unbalancedCurrent; ///< Current unbalance sensor
47 sensors.NumericSensor_4_0_3 lineFrequency; ///< Line AC frequency sensor
48 sensors.NumericSensor_4_0_3 phaseAngle; ///< Phase angle sensor
49 sensors.NumericSensor_4_0_3 crestFactor; ///< Crest factor sensor
50 sensors.StateSensor_4_0_3 powerQuality; ///< Power quality sensor
51 sensors.StateSensor_4_0_3 surgeProtectorStatus; ///< Surge protector status sensor
52 ResidualCurrentStateSensor_2_0_3 residualCurrentStatus; ///< Residual current monitor state sensor
53 };
54
55 /** %Inlet settings */
56 structure Settings {
57 string name; ///< User-defined name
58 };
59
60 /** Event: Inlet settings have been changed */
61 valueobject SettingsChangedEvent extends event.UserEvent {
62 Settings oldSettings; ///< Settings before change
63 Settings newSettings; ///< Settings after change
64 };
65
66 /** Event: Inlet has been enabled or disabled */
67 valueobject EnableStateChangedEvent extends event.UserEvent {
68 boolean enabled; ///< New enable state
69 };
70
71 /**
72 * Retrieve the inlet metadata.
73 *
74 * @return %Inlet metadata
75 */
76 MetaData getMetaData();
77
78 /**
79 * Get the inlet sensors.
80 *
81 * @return %Inlet sensors
82 */
83 Sensors getSensors();
84
85 /**
86 * Get the list of inlet poles.
87 *
88 * @return List of inlet poles
89 */
90 vector<Pole_5_0_0> getPoles();
91
92 /**
93 * Retrieve the inlet settings.
94 *
95 * @return %Inlet settings
96 */
97 Settings getSettings();
98
99 /**
100 * Change the inlet settings.
101 *
102 * @param settings New inlet settings
103 *
104 * @return 0 if OK
105 * @return 1 if any parameters are invalid
106 */
107 int setSettings(in Settings settings);
108
109 /**
110 * Enable/disable PDU operation for this inlet.
111 *
112 * When PDU operation is disabled the sensors for this inlet and all
113 * children will no longer be updated, and outlet switching is no
114 * longer allowed. This can be useful for multi-inlet units if one
115 * inlet is temporarily expected to be powered down.
116 *
117 * @param enabled \c true to enable PDU operation
118 */
119 void setEnabled(in boolean enabled);
120
121 /**
122 * Test whether PDU operation is enabled for this inlet.
123 *
124 * @return \c true if PDU operation is enabled
125 */
126 boolean isEnabled();
127 };
128
129 }
130
131 #endif
pdumodel::Inlet_2_0_4::Sensors::crestFactor
sensors::NumericSensor_4_0_3 crestFactor
Crest factor sensor.
Definition: Inlet.idl:49
pdumodel::Inlet_2_0_4::newSettings
Settings newSettings
Settings after change.
Definition: Inlet.idl:63
pdumodel::Inlet_2_0_4::Sensors::residualCurrent
sensors::NumericSensor_4_0_3 residualCurrent
Residual current sensor.
Definition: Inlet.idl:37
pdumodel::Inlet_2_0_4
Inlet interface
Definition: Inlet.idl:22
pdumodel::Inlet_2_0_4::Sensors::activePower
sensors::NumericSensor_4_0_3 activePower
Active power sensor.
Definition: Inlet.idl:39
pdumodel::Inlet_2_0_4::Sensors::unbalancedCurrent
sensors::NumericSensor_4_0_3 unbalancedCurrent
Current unbalance sensor.
Definition: Inlet.idl:46
pdumodel::EDevice
Common base interface for any kind of electrical device that is used in the PDU model, such as inlets, OCPs and outlets.
Definition: EDevice.idl:24
pdumodel::Inlet_2_0_4::Sensors::apparentPower
sensors::NumericSensor_4_0_3 apparentPower
Apparent power sensor.
Definition: Inlet.idl:41
pdumodel::Inlet_2_0_4::Settings
Inlet settings
Definition: Inlet.idl:56
pdumodel::Inlet_2_0_4::Sensors::lineFrequency
sensors::NumericSensor_4_0_3 lineFrequency
Line AC frequency sensor.
Definition: Inlet.idl:47
pdumodel::Inlet_2_0_4::MetaData::plugType
string plugType
Plug type.
Definition: Inlet.idl:27
pdumodel::Inlet_2_0_4::Sensors::current
sensors::NumericSensor_4_0_3 current
RMS current sensor.
Definition: Inlet.idl:35
pdumodel::Inlet_2_0_4::MetaData
Inlet metadata
Definition: Inlet.idl:25
pdumodel::Inlet_2_0_4::MetaData::label
string label
Inlet label
Definition: Inlet.idl:26
pdumodel::Inlet_2_0_4::Sensors::phaseAngle
sensors::NumericSensor_4_0_3 phaseAngle
Phase angle sensor.
Definition: Inlet.idl:48
pdumodel::Inlet_2_0_4::Sensors::displacementPowerFactor
sensors::NumericSensor_4_0_3 displacementPowerFactor
Displacement power factor sensor.
Definition: Inlet.idl:43
pdumodel::ResidualCurrentStateSensor_2_0_3
Residual current state sensor interface.
Definition: ResidualCurrentStateSensor.idl:17
pdumodel::Nameplate_2_0_0
Component nameplate information.
Definition: Nameplate.idl:23
pdumodel::Inlet_2_0_4::Sensors::peakCurrent
sensors::NumericSensor_4_0_3 peakCurrent
Peak current sensor.
Definition: Inlet.idl:36
pdumodel::Inlet_2_0_4::Sensors::residualDCCurrent
sensors::NumericSensor_4_0_3 residualDCCurrent
DC Residual current sensor.
Definition: Inlet.idl:38
pdumodel::Inlet_2_0_4::Settings::name
string name
User-defined name.
Definition: Inlet.idl:57
sensors
Sensors Model.
Definition: AccumulatingNumericSensor.idl:13
pdumodel
PDU Model.
Definition: Ade.idl:12
pdumodel::Inlet_2_0_4::MetaData::rating
Rating_2_0_0 rating
Numerical usage ratings.
Definition: Inlet.idl:29
pdumodel::Inlet_2_0_4::Sensors::apparentEnergy
sensors::NumericSensor_4_0_3 apparentEnergy
Apparent energy sensor.
Definition: Inlet.idl:45
pdumodel::Inlet_2_0_4::Sensors::voltage
sensors::NumericSensor_4_0_3 voltage
RMS voltage sensor.
Definition: Inlet.idl:34
pdumodel::Inlet_2_0_4::MetaData::namePlate
Nameplate_2_0_0 namePlate
Nameplate information
Definition: Inlet.idl:28
pdumodel::Inlet_2_0_4::Sensors::powerQuality
sensors::StateSensor_4_0_3 powerQuality
Power quality sensor.
Definition: Inlet.idl:50
sensors::NumericSensor_4_0_3
A sensor with numeric readings.
Definition: NumericSensor.idl:17
pdumodel::Rating_2_0_0
Numerical usage ratings.
Definition: Nameplate.idl:15
pdumodel::Inlet_2_0_4::Sensors::activeEnergy
sensors::NumericSensor_4_0_3 activeEnergy
Active energy sensor.
Definition: Inlet.idl:44
pdumodel::Inlet_2_0_4::Sensors::surgeProtectorStatus
sensors::StateSensor_4_0_3 surgeProtectorStatus
Surge protector status sensor.
Definition: Inlet.idl:51
pdumodel::Inlet_2_0_4::Sensors
Inlet sensors
Definition: Inlet.idl:33
sensors::StateSensor_4_0_3
Sensor with discrete readings.
Definition: StateSensor.idl:43
pdumodel::Inlet_2_0_4::Sensors::residualCurrentStatus
ResidualCurrentStateSensor_2_0_3 residualCurrentStatus
Residual current monitor state sensor.
Definition: Inlet.idl:52
pdumodel::Inlet_2_0_4::Sensors::powerFactor
sensors::NumericSensor_4_0_3 powerFactor
Power factor sensor.
Definition: Inlet.idl:42
pdumodel::Inlet_2_0_4::Sensors::reactivePower
sensors::NumericSensor_4_0_3 reactivePower
Reactive power sensor.
Definition: Inlet.idl:40